/*
 * gsampler-utils.h
 * Copyright (C) Lilian Monchalin 2011 <isaya07@users.sf.net>
 * 
 * gsampler is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * gsampler is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _GSAMPLER_UTILS_H_
#define _GSAMPLER_UTILS_H_

#include <gtk/gtk.h>

/* Déclaration d'une structure interne pour mémoriser le pointeur du widget
ainsi que son id.*/
struct Struct_list_widget {
	gpointer Sdata;
	gint Sid;
};

gboolean 	string_contains (const gchar* str1, const gchar* str2);
gchar* 		string_replace (const gchar* self, const gchar* old, const gchar* replacement);
gchar* 		string_slice (const gchar* self, glong start, glong end);

gboolean 	bool_parse (const gchar* str);
gchar* 		bool_to_string (gboolean self);
gdouble 	double_parse (const gchar* str);
gchar* 		double_to_string (gdouble self);

gchar* 		gsampler_utils_get_extension (const gchar* filename);
gchar* 		gsampler_utils_get_name (const gchar* filename);
gboolean	gsampler_utils_file_exist (const gchar* file);
gchar *		gsampler_utils_get_data_file (const gchar* file);
#ifdef G_OS_WIN32
gchar*		gsampler_utils_convert_win_path (const gchar* file_path);
#endif

GSList*		g_id_list_add (GSList *list, gint id, gpointer data);
GSList*		g_id_list_remove (GSList *list, gint id);
gpointer*	g_id_list_get (GSList *list, gint id);
gint		g_id_list_get_first_id (GSList *list);
gboolean	g_id_list_exist(GSList *list, gint id);
gint		g_id_list_size (GSList *list);
GSList*		g_id_list_remove_all(GSList *list);
void		g_id_list_free (GSList *list, gboolean clear);

GtkComboBox* gsampler_text_combo_create (void);
void		 gsampler_text_combo_append (GtkComboBox *combo, const gchar* text);
void		 gsampler_text_combo_insert (GtkComboBox *combo, const gchar* text, gint position);
gchar *		 gsampler_text_combo_get_active (GtkComboBox *combo);
void		 gsampler_text_combo_set_active (GtkComboBox *combo, const gchar* text);
void		 gsampler_text_combo_remove_all (GtkComboBox *combo);
void		 gsampler_text_combo_configure (GtkComboBox *combo);

#if GLIB_MINOR_VERSION < 28
void          g_slist_free_full (GSList *list, GDestroyNotify free_func);
#endif
#endif /* _GSAMPLER_UTILS_H_ */